// Fig. 4.13: fig04_13.cpp
// Static arrays are initialized to zero
#include <iostream.h>

void staticArrayInit( void );
void automaticArrayInit( void );

int main()
{
   cout << "First call to each function:\n";
   staticArrayInit();
   automaticArrayInit();

   cout << "\n\nSecond call to each function:\n";
   staticArrayInit();
   automaticArrayInit();
   cout << endl;

   return 0;
}

// function to demonstrate a static local array
void staticArrayInit( void )
{
   static int array1[ 3 ];
   int i;

   cout << "\nValues on entering staticArrayInit:\n";

   for ( i = 0; i < 3; i++ )
      cout << "array1[" << i << "] = " << array1[ i ] << "  ";

   cout << "\nValues on exiting staticArrayInit:\n";

   for ( i = 0; i < 3; i++ )
      cout << "array1[" << i << "] = " 
           << ( array1[ i ] += 5 ) << "  ";
}

// function to demonstrate an automatic local array
void automaticArrayInit( void )
{
   int i, array2[ 3 ] = { 1, 2, 3 };

   cout << "\n\nValues on entering automaticArrayInit:\n";

   for ( i = 0; i < 3; i++ )
      cout << "array2[" << i << "] = " << array2[ i ] << "  ";

   cout << "\nValues on exiting automaticArrayInit:\n";

   for ( i = 0; i < 3; i++ )
      cout << "array2[" << i << "] = " 
           << ( array2[ i ] += 5 ) << "  ";
}

