// Fig. 5.26: fig05_26.cpp
// Multipurpose sorting program using function pointers
#include <iostream.h>
#include <iomanip.h>

void bubble( int [], const int, int (*)( int, int ) );
int ascending( int, int );
int descending( int, int );

int main()
{
   const int arraySize = 10;
   int order, 
       counter,
       a[ arraySize ] = { 2, 6, 4, 8, 10, 12, 89, 68, 45, 37 };

   cout << "Enter 1 to sort in ascending order,\n" 
        << "Enter 2 to sort in descending order: ";
   cin >> order;
   cout << "\nData items in original order\n";
   
   for ( counter = 0; counter < arraySize; counter++ )
      cout << setw( 4 ) << a[ counter ];

   if ( order == 1 ) {
      bubble( a, arraySize, ascending );
      cout << "\nData items in ascending order\n";
   }
   else {
      bubble( a, arraySize, descending );
      cout << "\nData items in descending order\n";
   }

   for ( counter = 0; counter < arraySize; counter++ )
      cout << setw( 4 ) << a[ counter ];

   cout << endl;
   return 0;
}

void bubble( int work[], const int size, 
             int (*compare)( int, int ) )
{
   void swap( int *, int * );

   for ( int pass = 1; pass < size; pass++ )

      for ( int count = 0; count < size - 1; count++ )

         if ( (*compare)( work[ count ], work[ count + 1 ] ) )
            swap( &work[ count ], &work[ count + 1 ] );
}

void swap( int *element1Ptr, int *element2Ptr )
{
   int temp;

   temp = *element1Ptr;
   *element1Ptr = *element2Ptr;
   *element2Ptr = temp;
}

int ascending( int a, int b )
{
   return b < a;   // swap if b is less than a
}

int descending( int a, int b )
{
   return b > a;   // swap if b is greater than a
}

