// Fig. 16.2: fig16_02.cpp
// Card shuffling and dealing program using structures 
#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <time.h>

struct Card {
   char *face;
   char *suit;
};

void fillDeck( Card *, char *[], char *[] );
void shuffle( Card * );
void deal( Card * );

int main()
{
   Card deck[ 52 ];
   char *face[] = { "Ace", "Deuce", "Three", "Four", "Five",
                    "Six", "Seven", "Eight", "Nine", "Ten",
                    "Jack", "Queen", "King" };
   char *suit[] = { "Hearts", "Diamonds", "Clubs", "Spades" };

   srand( time( 0 ) );           // randomize 
   fillDeck( deck, face, suit );
   shuffle( deck );
   deal( deck );
   return 0;
}

void fillDeck( Card *wDeck, char *wFace[], char *wSuit[] )
{
   for ( int i = 0; i < 52; i++ ) {
      wDeck[ i ].face = wFace[ i % 13 ];
      wDeck[ i ].suit = wSuit[ i / 13 ];
   }
}

void shuffle( Card *wDeck )
{
   for ( int i = 0; i < 52; i++ ) {
      int j = rand() % 52;
      Card temp = wDeck[ i ];
      wDeck[ i ] = wDeck[ j ];
      wDeck[ j ] = temp;
   }
}

void deal( Card *wDeck )
{
   for ( int i = 0; i < 52; i++ )
      cout << setiosflags( ios::right ) 
           << setw( 5 ) << wDeck[ i ].face << " of " 
           << setiosflags( ios::left ) 
           << setw( 8 ) << wDeck[ i ].suit 
           << ( ( i + 1 ) % 2 ? '\t' : '\n' );
}

