// Fig 21.10: array2.cpp
// Member function definitions for class Array
#include <assert.h>
#include "array2.h"

// Default constructor for class Array (default size 10)
Array::Array( int arraySize )
{
   size = ( arraySize > 0 ? arraySize : 10 ); 
   cout << "Array constructor called for " 
        << size << " elements\n";

   ptr = new int[ size ]; // create space for array
   assert( ptr != 0 );    // terminate if memory not allocated

   for ( int i = 0; i < size; i++ )
      ptr[ i ] = 0;          // initialize array
}

// Destructor for class Array
Array::~Array() { delete [] ptr; }

// Overloaded output operator for class Array 
ostream &operator<<( ostream &output, const Array &a )
{
   int i;

   for ( i = 0; i < a.size; i++ )
      output << a.ptr[ i ] << ' ' ;

   return output;   // enables cout << x << y;
}