// Fig. 21.15: fig21_15.cpp
// Attempting to polymorphically call a function
// multiply inherited from two base classes.
#include <iostream.h>

class Base {
public:   
   virtual void print() const = 0;  // pure virtual
};

class DerivedOne : public Base {
public:
   // override print function
   void print() const { cout << "DerivedOne\n"; }
};

class DerivedTwo : public Base {
public:
   // override print function
   void print() const { cout << "DerivedTwo\n"; }
};

class Multiple : public DerivedOne, public DerivedTwo {
public:
   // qualify which version of function print
   void print() const { DerivedTwo::print(); }
};

int main()
{
   Multiple both;   // instantiate Multiple object
   DerivedOne one;  // instantiate DerivedOne object
   DerivedTwo two;  // instantiate DerivedTwo object

   Base *array[ 3 ];
   array[ 0 ] = &both;   // ERROR--ambiguous
   array[ 1 ] = &one;
   array[ 2 ] = &two;

   // polymorphically invoke print
   for ( int k = 0; k < 3; k++ )
      array[ k ] -> print();

   return 0;
}
