// Fig. 21.16: fig21_16.cpp
// Using virtual base classes.
#include <iostream.h>

class Base {
public:
   // implicit default constructor
   
   virtual void print() const = 0; // pure virtual
};

class DerivedOne : virtual public Base {
public:
   // implicit default constructor calls
   // Base default constructor 

   // override print function
   void print() const { cout << "DerivedOne\n"; }
};

class DerivedTwo : virtual public Base {
public:
   // implicit default constructor calls
   // Base default constructor 

   // override print function
   void print() const { cout << "DerivedTwo\n"; }
};

class Multiple : public DerivedOne, public DerivedTwo {
public:
   // implicit default constructor calls
   // DerivedOne and DerivedTwo default constructors

   // qualify which version of function print
   void print() const { DerivedTwo::print(); }
};

int main()
{
   Multiple both;   // instantiate Multiple object
   DerivedOne one;  // instantiate DerivedOne object
   DerivedTwo two;  // instantiate DerivedTwo object

   Base *array[ 3 ];
   array[ 0 ] = &both;
   array[ 1 ] = &one;
   array[ 2 ] = &two;

   // polymorphically invoke print
   for ( int k = 0; k < 3; k++ )
      array[ k ] -> print();

   return 0;
}
